
local creamery = ...

local myMonument = {
    DataType = "BUILDING",
    Id = _PastryPrefix .. "_CREAMERY",
    Name = _PastryPrefix .. "_CREAMERY_NAME",
    Description = _PastryPrefix .. "_CREAMERY_DESC",
    BuildingType = "GENERAL"
}

if (foundation.getGameVersion == nil or version.cmp(foundation.getGameVersion(), "1.6") < 0) then
    creamery:log("Hello World: game version anterior to 1.6")
    myMonument.BuildingPartSetList = {
		{
			Name = _PastryPrefix .. "_CREAMERY_NAME",
                	BuildingPartList = { _PastryPrefix .. "_CREAMERY_PART" }
                }
    } 
    _vjrTagBehaviorWork = "WORK_BEHAVIOR"
    _CoreBuildingZone = { Polygon = polygon.createRectangle( {4, 6} ) } 
else
    creamery:log("Hello World: game version " .. foundation.getGameVersion())
    myMonument.AssetCoreBuildingPart = _PastryPrefix .. "_CREAMERY_PART"
    _vjrTagBehaviorWork = "BEHAVIOR_WORK"

    _CoreBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {4, 6} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
    }}
end

creamery:register(myMonument)

creamery:registerAssetId("models/creamery.fbx/Prefab/creameryPart", _PastryPrefix .. "_CREAMERY_PREFAB")

creamery:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING_PART
	DataType = "BUILDING_PART",
--Cr l'objet
	Id = _PastryPrefix .. "_CREAMERY_PART",
	Description = "Faut bien a!",
        BuildingZone = _CoreBuildingZone,
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
--on dclare d'aller chercher _PastryPrefix_CREAMERY_PREFAB pour construire l'object final ( c'est dans le Fbx )
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _PastryPrefix .. "_CREAMERY_PREFAB"
	},
--Les ressources ncessaires.
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 10 }
		}
	},
	AssetBuildingFunction = "FUNCTION_" .. _PastryPrefix .. "_CREAMERY"
})

creamery:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "FUNCTION_" .. _PastryPrefix .. "_CREAMERY",
		WorkerCapacity = 2,
                RelatedJob = { Job = _PastryPrefix .. "_DAIRY_MAID", Behavior = _vjrTagBehaviorWork },
                InputInventoryCapacity = {
			{ Resource = "MILK", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "MILK", Quantity = 3 }
                },
                ResourceProduced = {
			{ Resource = _PastryPrefix .. "_BUTTER", Quantity = 1 }
                }
})

creamery:registerPrefabComponent("models/creamery.fbx/Prefab/creameryPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {4, 6}
})

creamery:registerPrefabComponent("models/creamery.fbx/Prefab/creameryPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 6 }
})

creamery:registerAssetId("models/creamery.fbx/Prefab/creameryPart/step_0/cheminee/SmokeEmitter", _PastryPrefix .. "_CREAMERY_SMOKE_EMITTER_PREFAB")

creamery:registerPrefabComponent("models/creamery.fbx/Prefab/creameryPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { _PastryPrefix .. "_CREAMERY_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

-- Register air vent particle system
creamery:registerPrefabComponent("models/creamery.fbx/Prefab/creameryPart/step_0/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

creamery:registerPrefabComponent("models/creamery.fbx/Prefab/creameryPart/step_0/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

