
local pastry = ...

local myMonument = {
    DataType = "BUILDING",
    Id = _PastryPrefix .. "_PASTRY_WORKPLACE",
    Name = _PastryPrefix .. "_PASTRY_WORKPLACE_NAME",
    Description = _PastryPrefix .. "_PASTRY_WORKPLACE_DESC",
    BuildingType = "GENERAL"
}

if (foundation.getGameVersion == nil or version.cmp(foundation.getGameVersion(), "1.6") < 0) then
    pastry:log("Hello World: game version anterior to 1.6")
    myMonument.BuildingPartSetList = {
		{
			Name = _PastryPrefix .. "_PASTRY_WORKPLACE_NAME",
                	BuildingPartList = { _PastryPrefix .. "_PASTRY_WORKPLACE_PART" }
                }
    } 
    _vjrTagBehaviorWork = "WORK_BEHAVIOR"
    _CoreBuildingZone = { Polygon = polygon.createRectangle( {4, 6} ) } 
else
    pastry:log("Hello World: game version " .. foundation.getGameVersion())
    myMonument.AssetCoreBuildingPart = _PastryPrefix .. "_PASTRY_WORKPLACE_PART"
    _vjrTagBehaviorWork = "BEHAVIOR_WORK"

    _CoreBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {4, 6} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
    }}
end

pastry:register(myMonument)

pastry:registerAssetId("models/pastry.fbx/Prefab/pastryPart", _PastryPrefix .. "_PASTRY_WORKPLACE_PREFAB")

pastry:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING_PART
	DataType = "BUILDING_PART",
--Cr l'objet
	Id = _PastryPrefix .. "_PASTRY_WORKPLACE_PART",
        BuildingZone = _CoreBuildingZone,
	Description = "Faut bien a!",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
--on dclare d'aller chercher " .. _PastryPrefix .. "_PASTRY_WORKPLACE_PREFAB pour construire l'object final ( c'est dans le Fbx )
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _PastryPrefix .. "_PASTRY_WORKPLACE_PREFAB"
	},
--Les ressources ncessaires.
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 10 }
		}
	},
	AssetBuildingFunction = "FUNCTION_" .. _PastryPrefix .. "_PASTRY"
})

pastry:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "FUNCTION_" .. _PastryPrefix .. "_PASTRY",
		WorkerCapacity = 3,
                RelatedJob = { Job = "BAKER", Behavior = _vjrTagBehaviorWork },
                InputInventoryCapacity = {
			{ Resource = _CommonEgg, Quantity = 50 },
			{ Resource = "FLOUR", Quantity = 50 },
			{ Resource = _PastryPrefix .. "_BUTTER", Quantity = 50 },
			{ Resource = "BERRIES", Quantity = 50 }
--,
--			{ Resource = "WOOD", Quantity = 50 }
                },
                ResourceListNeeded = {
			{ Resource = _CommonEgg, Quantity = 1 },
			{ Resource = "FLOUR", Quantity = 1 },
			{ Resource = _PastryPrefix .. "_BUTTER", Quantity = 1 },
			{ Resource = "BERRIES", Quantity = 1 }
--,
--			{ Resource = "WOOD", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = _PastryPrefix .. "_PASTRY", Quantity = 1 }
                }
})

pastry:registerPrefabComponent("models/pastry.fbx/Prefab/pastryPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {4, 6}
})

pastry:registerPrefabComponent("models/pastry.fbx/Prefab/pastryPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 6 }
})

pastry:registerAssetId("models/pastry.fbx/Prefab/pastryPart/step_0/cheminee/SmokeEmitter", _PastryPrefix .. "_PASTRY_SMOKE_EMITTER_PREFAB")

pastry:registerPrefabComponent("models/pastry.fbx/Prefab/pastryPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { _PastryPrefix .. "_PASTRY_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

-- Register air vent particle system
pastry:registerPrefabComponent("models/pastry.fbx/Prefab/pastryPart/step_0/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

pastry:registerPrefabComponent("models/pastry.fbx/Prefab/pastryPart/step_0/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

